unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    ScrollBoxImage: TScrollBox;
    Image1: TImage;
    Panel1: TPanel;
    ButtonLoad: TButton;
    CheckBox1: TCheckBox;
    Panel2: TPanel;
    ButtonNext: TButton;
    Button1: TButton;
    MemoFN: TMemo;
    LabelImageNo: TLabel;
    ButtonPanorama: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    CheckBoxUkecany: TCheckBox;
    ButtonReset: TButton;
    ButtonSave: TButton;
    SavePictureDialog1: TSavePictureDialog;
    CheckBoxPredel: TCheckBox;
    procedure ButtonLoadClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButtonPanoramaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonResetClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
  private
    { Private declarations }
    function porovnej_sloupce(o1, o2 : integer; c1, c2 : integer) : boolean;
    function jde_spojit(o1, o2 : integer) : integer;
  public
    { Public declarations }
    nacteno, spojeno : boolean;
    zobrazen, obrazku  : integer;
    a:array of tBitmap;
    procedure showim(imageno : integer);
    procedure spojit;
    procedure LoadFile(fn:string);
    procedure reset;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tform1.LoadFile(fn:string);
var n : integer;
begin
  setlength(a,length(a)+1);
  n := length(a)-1;

  a[n] := TBitmap.create;
  a[n].LoadFromFile(fn);

  if (a[n].Height <> a[1].Height) then MessageDlg('Neshodna vyska obrazku, '+fn+' vynechan',mtError, [mbCancel], 0)
  else begin
    nacteno := true;
    MemoFn.Lines.add(fn);
    inc(obrazku);
    Image1.Visible := true;
  end;
  showim(obrazku);
end;

procedure TForm1.ButtonLoadClick(Sender: TObject);
var i:integer;
begin
  if not OpenPictureDialog1.Execute then exit;

  for i:=0 to OpenPictureDialog1.Files.Count-1 do LoadFile(OpenPictureDialog1.Files[i]);

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  showim(zobrazen);
end;

procedure TForm1.showim(imageno: integer);
var pomerx, pomery,pomer : integer;
begin
  if not nacteno then exit;
  zobrazen := imageno;
  image1.top := 0;
  Image1.left := 0;
  if CheckBox1.Checked then
  begin
    pomerx := a[imageNo].Width div ScrollBoxImage.Width;
    pomery := a[imageNo].Height div ScrollBoxImage.Height;
    if pomerx>pomery then pomer := pomerx else pomer := pomery;
    inc(pomer);
    Image1.Width := a[imageNo].Width div pomer;
    Image1.Height := a[imageNo].Height div pomer;
  end
  else
  begin
    Image1.Width := a[imageNo].Width;
    Image1.Height := a[imageNo].Height;
  end;
  Image1.Picture.assign(a[imageNo]);
  if Imageno>0 then
     LabelImageNo.Caption := ' zobrazuji '+IntToStr(imageno)+' z '+IntToStr(obrazku)+' ('+MemoFN.lines[imageno-1]+')'
  else
     LabelImageNo.Caption := 'Panorama';
end;

procedure TForm1.ButtonNextClick(Sender: TObject);
begin
  if (zobrazen >=1) and (zobrazen<obrazku) then showim(zobrazen+1) else showim(1);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if (zobrazen >1) and (zobrazen<=obrazku) then showim(zobrazen-1) else showim(obrazku);
end;

function TForm1.porovnej_sloupce(o1, o2 : integer; c1, c2 : integer) : boolean;
var i:integer;
begin
  result := false;
  for i:=0 to a[1].Height-1 do
    if a[o1].canvas.pixels[c1,i]<>a[o2].canvas.pixels[c2,i] then exit;
  result := true;
end;

function TForm1.jde_spojit(o1, o2 : integer) : integer;
// pokud lze spojit, vraci o kolik bude presazeno, jinak 0
var i, j, sirka, c1, c2: integer;
    ok : boolean;
begin
  result := 0;
  sirka := a[o1].Width+0;

  for i:=5 to 15 do
  begin
    ok := true;
    for j:=0 to i-1 do
    begin
      c1 := sirka - i + j;
      c2 := j;
      if not porovnej_sloupce(o1,o2,c1,c2) then begin ok:=false; break; end;
    end;
    if ok then
      begin
        result := i;
        exit;
      end;
  end; //j
end;

procedure TForm1.spojit;
var i, j, n, co_hledam, sirka : integer;
    prev, next : array of integer;
    src, dst : tRect;
    spojitelnych : integer;

    index, posun, posunnext : array of integer;
begin
  SetLength(prev, obrazku+1);
  SetLength(next, obrazku+1);
  SetLength(posunnext, obrazku+1);

  // znulujeme stavove pole
  for i:=0 to obrazku do
  begin
    prev[i]:=0; next[i] := 0;
    posunnext[i] := 0;
  end;

  // a ted to vypukne
  for i:=1 to obrazku do
    for j:=1 to obrazku do
    begin
      if (i=j) then continue;
      n := jde_spojit(i,j);
      if n>0 then
      begin
        if CheckBoxUkecany.Checked then
           MessageDlg(format('Lze spojit obrazek %d a %d (presazeni %d px)',[i,j,n]),mtInformation,[mbOK],0);
        if (prev[j]<>0) or (next[i]<>0) then
        begin
             MessageDlg('Fotky lze spojit vice zpusoby, koncim',mtInformation,[mbCancel],0);
             exit;
        end;
        next[i] := j;
        prev[j] := i;
        posunnext[j] := n;
      end;
    end;

  // vyrobime poradi, jak bude panorama usporadane
  co_hledam := 0;
  setlength(index, obrazku+1);
  setlength(posun, obrazku+1);
  // kdo nema predchoziho, je prvni
  for j:=1 to obrazku do
  begin
    if prev[j]=0 then break;
  end;

  if j>obrazku then
  begin
    MessageDlg('Nemohu najit pocatecni obrazek - mozna jde o kruhove panorama, to zatm neumme'#13'Vas program by to ale umet mohl :-)',mtError, [mbCancel],0);
    exit;
  end;

  spojitelnych := 0;
  for i:=1 to obrazku do
    begin
      if j=0 then break;
      index[i] := j;
      posun[i] := posunnext[j];
      j:=next[j];
      inc(spojitelnych);
    end;

  if spojitelnych<>obrazku then MessageDlg('Nektere obrazky obrazky byly vypusteny, neslo je spojit',mtError, [mbCancel],0);

  sirka := 0;
  // v indexu je poradi obrazku, posun rika, o kolik je posunuto
  for i:=1 to spojitelnych do sirka := sirka + a[i].width - posun[i];

  a[0].Free; a[0]:= NIL;
  a[0] := TBitmap.Create;
  a[0].Width := sirka;
  a[0].Height := a[1].Height;
  a[0].Canvas.LineTo(a[0].Width,a[0].Height);

  sirka := 0;
  for j:=1 to spojitelnych do
  begin
    i := index[j];
    dst := Rect(sirka,0,sirka+a[i].Width,a[0].Height);
    src := Rect(0,0,a[i].Width, a[i].Height);
    a[0].Canvas.CopyRect(dst,a[i].canvas,src);
    if (CheckBoxPredel.Checked) then
    begin
     //a[0].Canvas.Pen.Color := clGray;
     a[0].Canvas.MoveTo(sirka,a[0].Height div 10);
     a[0].Canvas.LineTo(sirka,0);
     a[0].Canvas.MoveTo(sirka,a[0].Height - a[0].Height div 10);
     a[0].Canvas.LineTo(sirka,a[0].Height);
    end;
    sirka := sirka + a[i].width - posun[j+1];
  end;
  showim(0);
  spojeno := true;
end;

procedure TForm1.ButtonPanoramaClick(Sender: TObject);
begin
  if not nacteno then MessageDlg('Z ceho?',mtError, [mbCancel],0)
  else spojit;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 reset;
end;

procedure TForm1.reset;
var i : Integer;
begin
 for i:=1 to obrazku do a[i].Free;
 MemoFN.Clear;
 nacteno := false;
 spojeno := false;
 obrazku := 0;
 LabelImageNo.Caption := '?';
 SetLength(a,1);
 Image1.Visible := false;
end;

procedure TForm1.ButtonResetClick(Sender: TObject);
begin
  reset;
end;

procedure TForm1.ButtonSaveClick(Sender: TObject);
begin
 if spojeno then
 begin
    if SavePictureDialog1.Execute then a[0].SaveToFile(SavePictureDialog1.FileName);
 end else MessageDlg('Neni co ulozit',mtError, [mbCancel],0)
end;

end.
